<template>
  <div class="px-8 pt-6  mb-4 w-full">
    <div class="mb-4">
      <label class="block text-gray-700 text-sm font-bold mb-2" for="username">
        Judul
      </label>
      <input
        id="judul"
        v-model="title"
        class="appearance-none border rounded w-full py-2 px-3 text-black-700 leading-tight focus:outline-none focus:shadow-outline"
        type="text"
        placeholder="Contoh: Beras untuk Warga Beji Timur"
      />
    </div>
    <div class="mb-4">
      <label class="block text-gray-700 text-sm font-bold mb-2" for="username">
        Keterangan
      </label>
      <textarea
        id="keterangan"
        v-model="note"
        class="appearance-none border rounded w-full py-2 px-3 text-black-700 leading-tight focus:outline-none focus:shadow-outline"
        type="text"
        rows="4"
        placeholder="Contoh: Dibutuhkan 10 kilogram beras untuk dapur umum warga di Beji Timur."
      />
    </div>
    <div class="mb-4">
      <label class="block text-gray-700 text-sm font-bold mb-2" for="username">
        Nama Pemberi Bantuan
      </label>
      <input
        id="pemberiBantuan"
        v-model="providerName"
        class="appearance-none border rounded w-full py-2 px-3 text-black-700 leading-tight focus:outline-none focus:shadow-outline"
        type="text"
        placeholder="Contoh: Ana Budi Darma"
      />
    </div>
    <div class="mb-4">
      <label class="block text-gray-700 text-sm font-bold mb-2" for="username">
        Nomor Handphone
      </label>
      <Cleave
        id="phoneNumberf"
        v-model="phoneNumber"
        :options="phoneCleaveOption"
        class="appearance-none border rounded w-full py-2 px-3 text-black-700 leading-tight focus:outline-none focus:shadow-outline"
        type="text"
        placeholder="08123456789"
      />
      <label v-if="formType === 'C'" class="md:w-2/3 block text-gray-500">
        <input v-model="canShowPhoneNumber" class="mr-2 leading-tight" type="checkbox" />
        <span class="text-sm">
          Izinkan pengguna yang terverifikasi untuk melihat nomor inis
        </span>
      </label>
      <label class="md:w-2/3 block text-gray-500">
        <input v-model="waAvailable" class="mr-2 leading-tight" type="checkbox" />
        <span class="text-sm">
          Saya dapat dihubungi melalui WhatsApp
        </span>
      </label>
    </div>
    <ItemDetailsSection />
    <div class="wrapper--button mt-10">
      <label class="md:w-2/3 block text-gray-500">
        <input v-model="agree" class="mr-2 leading-tight" type="checkbox" />
        <span class="text-sm">
          Saya telah menyetujui
          <a href="javascript:;" @click="showTNC">syarat dan ketentuan</a>
        </span>
      </label>
      <div class="mt-3">
        <Button type="submit" class="px-10 py-2 rounded-md" main :on-click="nextStep">Lanjutkan</Button>
        <Button class="px-8 py-2" ghost :on-click="showCancelWarning">Batalkan</Button>
      </div>
    </div>
  </div>
</template>

<script>
const Button = () => import('~/components/Button');
const ItemDetailsSection = () => import('~/components/Form/Section2/item-details-section');
import Cleave from 'vue-cleave-component';
import 'cleave.js/dist/addons/cleave-phone.id.js';
import formMixin from '~/components/Form/form-mixin';

import SimpleVueValidator from 'simple-vue-validator';
const Validator = SimpleVueValidator.Validator;
export default {
  components: {
    Button,
    ItemDetailsSection,
    Cleave,
  },
  mixins: [formMixin, SimpleVueValidator.mixin],
  data: () => ({
    list: 1,
    phoneCleaveOption: {
      phone: true,
      phoneRegionCode: 'id',
    },
  }),

  computed: {
    title: {
      get() {
        return this.$store.state.form.title;
      },
      set(value) {
        this.$store.commit('form/SET_TITLE', value);
      },
    },
    note: {
      get() {
        return this.$store.state.form.note;
      },
      set(value) {
        this.$store.commit('form/SET_NOTE', value);
      },
    },
    providerName: {
      get() {
        return this.$store.state.form.provider_name;
      },
      set(value) {
        this.$store.commit('form/SET_PROVIDER_NAME', value);
      },
    },
    phoneNumber: {
      get() {
        return this.$store.state.form.phone_number;
      },
      set(value) {
        this.$store.commit('form/SET_PHONE_NUMBER', value);
      },
    },
    canShowPhoneNumber: {
      get() {
        return this.$store.state.form.can_show_phone_number;
      },
      set(value) {
        this.$store.commit('form/SET_CAN_SHOW_PHONE_NUMBER', value);
      },
    },
    agree: {
      get() {
        return this.$store.state.form.agree;
      },
      set(value) {
        this.$store.commit('form/SET_AGREE', value);
      },
    },
    waAvailable: {
      get() {
        return this.$store.state.form.wa_available;
      },
      set(value) {
        this.$store.commit('form/SET_WA_AVAILABLE', value);
      },
    },
    itemDetails() {
      return this.$store.state.form.item_details;
    },
    formType() {
      return this.$store.state.form.type;
    },
    validItemDetails() {
      return this.$store.getters['form/validItemDetails'];
    },
  },

  validators: {
    title(value) {
      return Validator.value(value).required();
    },
    providerName(value) {
      return Validator.value(value).required();
    },
    phoneNumber(value) {
      return Validator.value(value).required();
    },
    note(value) {
      return Validator.value(value).required();
    },
  },

  mounted() {},

  methods: {
    async validate() {
      let validOverall = false;
      const valid = await this.$validate();
      if (!valid) this.showFormNotComplete();
      else if (!this.checkItemDetails()) {
        this.showItemDetailsEmpty();
      } else if (!this.agree) {
        this.showNotAgreeWarning();
      } else {
        validOverall = true;
      }
      return validOverall;
    },
    async nextStep() {
      if (await this.validate()) {
        this.$store.dispatch('form/switchActiveTab', 3);
      }
    },
    checkItemDetails() {
      return this.validItemDetails.length > 0;
    },
    showTNC() {
      this.$swal({
        html:
          '<b>Persyaratan dan Ketentuan Pengguna</b><br>· Tujuan dari pendaftaran nomor Whatsapp di dalam situs ini adalah agar KawalCOVID19 dapat menghubungi dan verifikasi data antara pemberi bantuan dan penerima bantuan (berupa bahan pokok/sembako/bantuan sosial) apabila diperlukan. · Pemberi bantuan dan penerima bantuan menjamin bahwa dalam memberikan data dan informasi terkait bantuan yang diberikan kepada KawalCOVID19 adalah benar dan akan mempertanggungjawabkan apabila data dan informasi yang diberikan tidak akurat. · Pengguna yang bukan atau pemberi/penerima bantuan bersedia mendaftarkan nomor Whatsapp di halaman berbagibantuan.kawalcovid19.id dengan sadar dan tanpa ada paksaan dari pihak manapun. · Selain untuk menghubungi dan verifikasi Pengguna dalam pemberian/penerimaan bantuan, Pengguna mendaftarkan nomor Whatsapp di halaman berbagibantuan.kawalcovid19.id karena ingin mendapatkan informasi tentang COVID-19 secara cepat dan akurat. · Pengguna bersedia menerima informasi yang dibagikan oleh KawalCOVID19 kepada saya melalui nomor Whatsapp yang didaftarkan. · Jika ada kesalahan atau ketidakakuratan informasi yang saya dapatkan atau temukan dari KawalCOVID19, saya akan menghubungi Admin KawalCOVID19 melalui @KawalCOVID19.',
        showConfirmButton: false,
      });
    },
    addItem() {
      this.list += 1;
    },
    deleteItem() {
      if (this.list === 1) {
        return null;
      }
      this.list -= 1;
    },
  },
};
</script>

<style lang="scss" scoped>
input,
textarea {
  color: $black-alt;
}
a {
  color: $red;
}
.btn-add {
  color: $red !important;
}
.dark-mode {
  label {
    color: $white;
  }
}
.white-mode {
  label {
    color: $black-alt;
  }
}
</style>
